###################################################
### chunk number 1:  eval=FALSE
###################################################
## #line 46 "d:/Rcompile/CRANpkg/local/2.12/spacetime/inst/doc/stpg.Rnw"
## library(RPostgreSQL)


###################################################
### chunk number 2: 
###################################################
#line 49 "d:/Rcompile/CRANpkg/local/2.12/spacetime/inst/doc/stpg.Rnw"
library(spacetime)


###################################################
### chunk number 3: 
###################################################
#line 60 "d:/Rcompile/CRANpkg/local/2.12/spacetime/inst/doc/stpg.Rnw"
dbname = "postgis"
user = "user"
password = "password"


###################################################
### chunk number 4:  eval=FALSE
###################################################
## #line 67 "d:/Rcompile/CRANpkg/local/2.12/spacetime/inst/doc/stpg.Rnw"
## drv <- dbDriver("PostgreSQL")
## con <- dbConnect(drv, dbname=dbname, user=user, password=password)


###################################################
### chunk number 5:  eval=FALSE
###################################################
## #line 77 "d:/Rcompile/CRANpkg/local/2.12/spacetime/inst/doc/stpg.Rnw"
## dbRemoveTable(con, "rural_attr")
## dbRemoveTable(con, "rural_space")
## dbRemoveTable(con, "rural_time")
## dbRemoveTable(con, "space_select")


###################################################
### chunk number 6:  eval=FALSE
###################################################
## #line 88 "d:/Rcompile/CRANpkg/local/2.12/spacetime/inst/doc/stpg.Rnw"
## data(air)
## rural = as(rural, "STSDF")
## p = rural@sp
## sp = SpatialPointsDataFrame(p, data.frame(geom_id=1:length(p)))
## library(rgdal)
## OGRstring = paste("PG:dbname=", dbname, " user=", user, 
## 	" password=", password, sep = "")
## writeOGR(sp, OGRstring, "rural_space", driver = "PostgreSQL")


###################################################
### chunk number 7:  eval=FALSE
###################################################
## #line 101 "d:/Rcompile/CRANpkg/local/2.12/spacetime/inst/doc/stpg.Rnw"
## df = data.frame(time = index(rural@time), time_id = 1:nrow(rural@time))
## dbWriteTable(con, "rural_time", df)
## idx = "create index time_idx on rural_time (time);"
## dbSendQuery(con, idx)


###################################################
### chunk number 8:  eval=FALSE
###################################################
## #line 110 "d:/Rcompile/CRANpkg/local/2.12/spacetime/inst/doc/stpg.Rnw"
## idx = rural@index
## names(rural@data) = "pm10" # lower case
## df = cbind(data.frame(geom_id = idx[,1], time_id = idx[,2]), rural@data)
## dbWriteTable(con, "rural_attr", df)


###################################################
### chunk number 9: 
###################################################
#line 123 "d:/Rcompile/CRANpkg/local/2.12/spacetime/inst/doc/stpg.Rnw"
setClass("ST_PG", representation("ST", 
	space_table = "character",
	time_table = "character",
	attr_table = "character",
	attr = "character",
	con = "PostgreSQLConnection"))


###################################################
### chunk number 10:  eval=FALSE
###################################################
## #line 132 "d:/Rcompile/CRANpkg/local/2.12/spacetime/inst/doc/stpg.Rnw"
## rural_proxy = new("ST_PG", 
## 	ST(rural@sp, rural@time),
## 	space_table = "rural_space",
## 	time_table = "rural_time",
## 	attr_table = "rural_attr",
## 	attr = "pm10",
## 	con = con)


###################################################
### chunk number 11: 
###################################################
#line 146 "d:/Rcompile/CRANpkg/local/2.12/spacetime/inst/doc/stpg.Rnw"
.SqlTime = function(x, j) {
	stopifnot(is.character(j))
	t = .parseISO8601(j)
	t1 = paste("'", t$first.time, "'", sep = "")
	t2 = paste("'", t$last.time, "'", sep = "")
	what = paste("geom_id, time_id", paste(x@attr, collapse = ","), sep = ", ")
	paste("SELECT", what, "FROM", x@attr_table, "AS a JOIN", x@time_table,
		"AS b USING (time_id) WHERE b.time >= ", t1, "AND b.time <=", t2,";")
}
.SqlSpace = function(x, i) {
	stopifnot(is(i, "Spatial"))
	writeOGR(i, OGRstring, "space_select", driver = "PostgreSQL")
	what = paste("geom_id, time_id", paste(x@attr, collapse = ","), sep = ", ")
	paste("SELECT",  what, "FROM",  x@attr_table, 
		"AS a JOIN (SELECT p.wkb_geometry, p.geom_id FROM",
		x@space_table, " AS p, space_select AS q",
		"WHERE ST_Intersects(p.wkb_geometry, q.wkb_geometry))",
		"AS b USING (geom_id);")
}


###################################################
### chunk number 12: 
###################################################
#line 171 "d:/Rcompile/CRANpkg/local/2.12/spacetime/inst/doc/stpg.Rnw"
setMethod("[", "ST_PG", function(x, i, j, ... , drop = TRUE) {
	stopifnot(missing(i) != missing(j)) # either of them present
	if (missing(j))
		sql = .SqlSpace(x,i)
	else
		sql = .SqlTime(x,j)
	print(sql)
	df = dbGetQuery(x@con, sql)
	STSDF(x@sp, x@time, df[x@attr], as.matrix(df[c("geom_id", "time_id")]))
})


###################################################
### chunk number 13:  eval=FALSE
###################################################
## #line 183 "d:/Rcompile/CRANpkg/local/2.12/spacetime/inst/doc/stpg.Rnw"
## pm10_20050101 = rural_proxy[, "2005-01-01"]
## summary(pm10_20050101)
## summary(rural[,"2005-01-01"])
## 
## pm10_NRW = rural_proxy[DE_NUTS1[10,],]
## summary(pm10_NRW)
## summary(rural[DE_NUTS1[10,],])


###################################################
### chunk number 14:  eval=FALSE
###################################################
## #line 195 "d:/Rcompile/CRANpkg/local/2.12/spacetime/inst/doc/stpg.Rnw"
## dim(pm10_NRW)
## pm10_NRW = pm10_NRW[T,]
## dim(pm10_NRW)


###################################################
### chunk number 15:  eval=FALSE
###################################################
## #line 201 "d:/Rcompile/CRANpkg/local/2.12/spacetime/inst/doc/stpg.Rnw"
## object.size(rural)
## object.size(pm10_20050101)
## object.size(pm10_NRW)


###################################################
### chunk number 16:  eval=FALSE
###################################################
## #line 210 "d:/Rcompile/CRANpkg/local/2.12/spacetime/inst/doc/stpg.Rnw"
## dbDisconnect(con)
## dbUnloadDriver(drv)


